org.cpsolver.ifs.solution

## Interface SolutionComparator<V extends Variable<V,T>,T extends Value<V,T>>

- Type Parameters:
    `V` - Variable
    `T` - Value
  All Known Subinterfaces:
    StudentWeights
  All Known Implementing Classes:
    EqualStudentWeights, GeneralSolutionComparator, MPPSolutionComparator, OriginalStudentWeights, PriorityStudentWeights, ResectioningWeights, StudentSchedulingAssistantWeights, TimetableComparator

      public interface SolutionComparator<V extends Variable<V,T>,T extends Value<V,T>>

  IFS solution comparator.
  The solution comparator compares two solutions: the current solution and the best solution found. This comparison can be based on several criteria. For example, it can lexicographically order solutions according to the number of unassigned variables (smaller number is better) and the number of violated soft constraints.
  Version:
    IFS 1.3 (Iterative Forward Search)
    Copyright (C) 2006 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller
  See Also:
    `Solution`, `Solver`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `isBetterThanBestSolution(Solution<V,T> currentSolution)` Compares two solutions.

- - ### Method Detail

    - #### isBetterThanBestSolution

          boolean isBetterThanBestSolution(Solution<V,T> currentSolution)

      Compares two solutions. Returns true if the given solution is better than its best ever found solution (see `Solution.saveBest()` and `Solution.restoreBest()`).
      Parameters:
        `currentSolution` - given solution
      Returns:
        true if the given solution is better than the best ever found solution